//****************************************************************************
//Copyright (C) 2005-2006 Beijing BlueDJ Technology Co.,Ltd. All rights reserved.

//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either version 2
//of the License, or (at your option) any later version.

//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.

//You should have received a copy of the GNU General Public License
//along with this program (in the file LICENSE.GPL); if not, write to the Free Software
//Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

//Please visit http://www.bluedj.com for more infomation about us.
//Contact us at ggwizard@gmail.com or darkdong@gmail.com.
//****************************************************************************/


#ifndef DJGAMETRACEMANAGER_H
#define DJGAMETRACEMANAGER_H

#include <QtCore>
#include "DJBaseGlobal.h"

#define DJGAME_GAMETRACE_LAST			0xFFFF
#define DJGAME_GAMETRACE_FIRST			0x01

class DJ_BASE_EXPORT DJGameTraceManager
{
	public :
		DJGameTraceManager();
		DJGameTraceManager(DJGameTraceManager& a);
		DJGameTraceManager(QString & filename,quint16 headlen=0);
		virtual ~DJGameTraceManager();
	
		int operator=(DJGameTraceManager& a);
	
		virtual bool Next(char * buffer,quint16 *pshLen);
		virtual bool GetTrace(unsigned short shStep,char * buffer,quint16 *shLen);
		virtual bool AppendTrace(PGeneralGameTrace2Head ptrace);
	
		virtual void SaveGameTrace(char *head,quint16 headlen);
	
		QString GetFileName();
		unsigned short GetCurrentStepNumber();
		unsigned short GetTotalSteps();
	private :
		QString GetTempSaveFileName();
		void CreateNewFile(QString &filename,quint16 headlen);
		bool __GetTrace(QString &filename,unsigned short shStep,char * buffer,quint16 *pshLen);
		bool __AppendTrace(QString &filename,PGeneralGameTrace2Head ptrace);
	
		QString c_filename;
		unsigned short c_shCurStep;
};

#endif
